REM Extracts Keps from a file of two line elements
REM Displays and saves in OZ format
REM Written by C.Wallis G3CWV
REM 28-June-94
REM ------
ON ERROR GOTO error.trap
TRUE = -1
FALSE = 0
INPUT "Enter input file name  "; in.File$
OPEN in.File$ FOR INPUT AS #1
INPUT "Enter name of output file "; out.File$
OPEN out.File$ FOR OUTPUT AS #2
sat.name$ = "": line1$ = "": line2$ = ""
chk% = FALSE
PRINT #2, "--------------------------------------------------------------------------------"
PRINT #2, "NAME         EPOCH    INCL   RAAN  ECCY   ARGP    MA      MM      DCY      REVN"
    PRINT "NAME         EPOCH    INCL   RAAN  ECCY   ARGP    MA      MM      DCY      REVN"
PRINT #2, "--------------------------------------------------------------------------------"
DO              'Main program loop
 sat.name$ = line1$
 line1$ = line2$
 INPUT #1, line$
 line2$ = line$
 IF NOT EOF(1) THEN GOSUB check
 IF chk% THEN GOSUB save.kep
LOOP UNTIL EOF(1)
CLOSE #1, #2
SYSTEM
REM ------
check:
 REM Checks that three lines of data are correct
 REM Inputs sat.name$, line1$, line2$
 REM Output chk% ... TRUE if OK
 chk% = TRUE
 IF LEN(sat.name$) > 12 THEN chk% = FALSE
 IF VAL(LEFT$(line1$, 1)) <> 1 THEN chk% = FALSE
 IF VAL(LEFT$(line2$, 1)) <> 2 THEN chk% = FALSE
 IF ((LEN(line1$) <> 69) OR (LEN(line2$) <> 69)) THEN chk% = FALSE
 line$ = line1$
 GOSUB check.sum
 line$ = line2$
 GOSUB check.sum
RETURN
REM ------
check.sum:
 REM Tests line of data for checksum
 REM Input line$
 REM Output chk% (Only set to false if checksum fails)
 sum% = 0
 FOR I% = 1 TO 68
  ch$ = MID$(line$, I%, 1)
  SELECT CASE ch$
    CASE "+"
        sum% = sum% + 2
    CASE "-"
        sum% = sum% + 1
    CASE ELSE
        sum% = sum% + VAL(ch$)
  END SELECT
 NEXT I%
 ch$ = MID$(line$, 69, 1)
 sum% = (sum% MOD 10)
 IF sum% <> VAL(ch$) THEN chk% = FALSE
RETURN
REM-------
save.kep:
 REM The output routine
 YE = INT(VAL(MID$(line1$, 19, 2)))
 TE# = VAL(MID$(line1$, 21, 12))
 IN = VAL(MID$(line2$, 9, 8))
 RA = VAL(MID$(line2$, 18, 8))
 EC = VAL(MID$(line2$, 27, 7)) * .0000001
 AP = VAL(MID$(line2$, 35, 8))
 MA = VAL(MID$(line2$, 44, 8))
 MM# = VAL(MID$(line2$, 53, 9))
 DC = VAL(MID$(line1$, 34, 10))
 RV = INT(VAL(MID$(line2$, 64, 5)))
 format$ = "\      \ ## ###.##### ##.## ###.## #.#### ###.## ###.## ##.##### ##.#^^^^ #####"
 PRINT USING format$; sat.name$; YE; TE#; IN; RA; EC; AP; MA; MM#; DC; RV
 PRINT #2, USING format$; sat.name$; YE; TE#; IN; RA; EC; AP; MA; MM#; DC; RV
RETURN
REM ------
error.trap:
 SELECT CASE ERR
    CASE 53
        PRINT "File not found"
    CASE 52, 64, 76, 68
        PRINT "Bad file or path name"
    CASE 71
        PRINT "Disk not ready"
    CASE 72
        PRINT "Disk error"
 END SELECT
 PRINT "Error number  "; ERR
 SYSTEM
 REM --------------

